package cn.gov.customs.wxjy.statReport.service.impl;

import cn.gov.customs.cacp.sdks.core.user.trans.CacpTransUser;
import cn.gov.customs.wxjy.common.exception.ServiceException;
import cn.gov.customs.wxjy.common.utils.StringUtils;
import cn.gov.customs.wxjy.common.utils.bean.BeanValidators;
import cn.gov.customs.wxjy.common.utils.uuid.SnowflakeIdWorker;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import javax.validation.Validator;
import java.util.List;
import org.apache.commons.collections4.CollectionUtils;
import cn.gov.customs.wxjy.common.utils.DateUtils;
import com.github.pagehelper.PageInfo;
import cn.gov.customs.wxjy.statReport.dao.CustomMStatFMapper;
import cn.gov.customs.wxjy.statReport.pojo.CustomMStatF;
import cn.gov.customs.wxjy.statReport.pojo.CustomMStatFQuery;
import cn.gov.customs.wxjy.statReport.service.ICustomMStatFService;

/**
 * 按业务现场关区分类Service业务层处理
 *
 * @author xiong
 * @date 2025-12-12
 */
@Service
@Slf4j
@RequiredArgsConstructor
public class CustomMStatFServiceImpl implements ICustomMStatFService {

    private final CustomMStatFMapper customMStatFMapper;

    private final Validator validator;

    /**
     * 查询按业务现场关区分类
     *
     * @param ID 按业务现场关区分类主键
     * @return 按业务现场关区分类
     */
    @Override
    public CustomMStatF selectByID(String ID) {
        return customMStatFMapper.selectByID(ID);
    }

    /**
     * 分页查询按业务现场关区分类列表
     *
     * @param query
     * @return 按业务现场关区分类
     */
    @Override
    public PageInfo<CustomMStatF> selectPageList(CustomMStatFQuery query) {
        return PageInfo.of(customMStatFMapper.selectList(query));
    }

    /**
     * 查询按业务现场关区分类列表
     *
     * @param query
     * @return 按业务现场关区分类
     */
    @Override
    public List<CustomMStatF> selectList(CustomMStatFQuery query) {
        return customMStatFMapper.selectList(query);
    }

    /**
     * 新增按业务现场关区分类
     *
     * @param customMStatF 按业务现场关区分类
     * @return 结果
     */
    @Override
    public int insert(CustomMStatF customMStatF) {
            return customMStatFMapper.insert(customMStatF);
    }

    /**
     * 修改按业务现场关区分类
     *
     * @param customMStatF 按业务现场关区分类
     * @return 结果
     */
    @Override
    public int update(CustomMStatF customMStatF) {
        return customMStatFMapper.update(customMStatF);
    }

    /**
     * 批量删除按业务现场关区分类
     *
     * @param ids 需要删除的按业务现场关区分类主键
     * @return 结果
     */
    @Override
    public int deleteByIDs(String[] ids) {
        return customMStatFMapper.deleteByIDs(ids);
    }

    /**
     * 删除按业务现场关区分类信息
     *
     * @param ID 按业务现场关区分类主键
     * @return 结果
     */
    @Override
    public int deleteByID(String ID) {
        return customMStatFMapper.deleteByID(ID);
    }

    /**
     * 逻辑删除按业务现场关区分类信息
     *
     * @param ID 按业务现场关区分类主键
     * @return 结果
     */
    @Override
    public int logicDelete(String ID) {

        return customMStatFMapper.logicDelete(ID);
    }

    /**
     * 导入按业务现场关区分类数据
     *
     * @param customMStatFList 按业务现场关区分类数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param cacpTransUser 操作用户
     * @return 结果
     */
    @Override
    public String importCustomMStatF(List<CustomMStatF> customMStatFList, Boolean isUpdateSupport, CacpTransUser cacpTransUser) {
        if (CollectionUtils.isEmpty(customMStatFList)) {
            throw new ServiceException("导入数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        for (CustomMStatF customMStatF : customMStatFList) {
            try {

                BeanValidators.validateWithException(validator, customMStatF);
                //id名称不统一，自行处理
                customMStatF.setCreateTime(DateUtils.getNowDate());
                customMStatF.setUpdateTime(DateUtils.getNowDate());
                customMStatF.setCreateUser(cacpTransUser.getUserId());
                customMStatF.setCreateDept(cacpTransUser.getParentGuid());

                customMStatFMapper.insert(customMStatF);
                successNum++;
                successMsg.append("<br/>" + successNum + "、 " + cacpTransUser.getUserName() + " 导入成功");

            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、" + cacpTransUser.getUserName() + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
}
